IntraFont.init()
IntraFont.load("flash0:/font/ltn8.pgf", 1)

local oldpad = Controls.read()

math.randomseed(os.time())

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

local intro = Image.load("Images/intro.png")
local fond = Image.load("Images/fond.png")
local selecteurIMG = Image.load("Images/selecteur.png")
local zic = Image.load("Images/fond_zic.png")
local boule = Image.load("Images/boule.png")
local bouton = Image.load("Images/bouton.png")
local bouton2 = Image.load("Images/bouton2.png")
local batterie = Image.load("Images/bat.png")
local selecteurM = Image.load("Images/selecteur2.png")

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

local blanc = Color.new(255, 255, 255)
local bleu = Color.new(0, 0, 255)
local bleuC = Color.new(5, 150, 245)
local noir = Color.new(0, 0, 0)
local gris = Color.new(159, 159, 159)
local blancI = IntraFont.color(255, 255, 255, 255)
local noirI = IntraFont.color(0, 0, 0, 255)
local noirI2 = IntraFont.color(0, 0, 0, 150)
local rougeI = IntraFont.color(255, 0, 0, 255)
local grisI = IntraFont.color(159, 159, 159, 255)
local gris2I = IntraFont.color(180, 180, 180, 255)

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

System.currentDirectory("ms0:/MUSIC")
local fichier = System.listDirectory()

local statut = "intro"

local LuaMp3 = { }

local selecteur = { }
selecteur[1] = { s = 1, posX = 10 }
selecteur[2] = { s = 2, posX = 202 }
selecteur[3] = { s = 1, posY = 90 }

local alpha = { }
alpha.a = 255
alpha.img = Image.createEmpty(480,272)
alpha.statut = "in"

local y = 90
local partie = 1
local saut = 4

local stat_mp3 = 1
local alea = 0

local file = io.open("ms0:/PSP/GAME/LuaMP3/Fichiers/aleatoire.txt", "r")
local aleatoire = file:read()
file:close()

local file2 = io.open("ms0:/PSP/GAME/LuaMP3/Fichiers/repetition.txt", "r")
local repetition = file2:read()
file2:close()

local file3 = io.open("ms0:/PSP/GAME/LuaMP3/Fichiers/cpu.txt", "r")
local CPU = file3:read()
file3:close()

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function LuaMp3.intro()
	screen:blit(0, 0, intro)

	if alpha.statut == "in" then
		alpha.img:clear(Color.new(0, 0, 0, alpha.a))
		screen:blit(0, 0, alpha.img)
		alpha.a = alpha.a -5
		if alpha.a <= -10 then
			System.sleep(1000)
			alpha.statut = "out"
		end
	elseif alpha.statut == "out" then
		alpha.img:clear(Color.new(255, 255, 255, alpha.a))
		screen:blit(0, 0, alpha.img)
		alpha.a = alpha.a +8
		if alpha.a >= 255 then
			System.sleep(800)
			statut = "lecteur"
		end
	end
end

function LuaMp3.heure(posY, couleur)
	local heures = System.getTime(1)
	local min = System.getTime(2)
	
	if System.getTime(5) == "pm" then
		heures = heures +12
	end
	Gu.start3d()
		if System.getTime(2) < 10 then
			IntraFont.print(480/2-string.len(heures..":".."0"..min)*10/2, posY, heures..":".."0"..min, 1, couleur, 0)
		else
			IntraFont.print(480/2-string.len(heures..":"..min)*10/2, posY, heures..":"..min, 1, couleur, 0)
		end
	Gu.end3d()
end

function LuaMp3.pourcent(x, y, x0, y0, couleur, couleur2)
	screen:fillRect(x, y, x0, y0, couleur)
	screen:fillRect(x, y, Mp3me.percent()*2, y0, couleur2)
end

function LuaMp3.dir(posY)
	Gu.start3d()
		if System.currentDirectory() == "ms0:" then
			IntraFont.print(480/2-string.len("ms0:/")*8/2, posY, "ms0:/", 1, blancI, 0)
		else
			IntraFont.print(480/2-string.len(System.currentDirectory())*5/2, posY, string.sub(System.currentDirectory(), 6), 1, blancI, 0)
		end
	Gu.end3d()
end

function LuaMp3.info(posY)
	screen:print(10, posY, "X : Entrer", blanc)
	screen:print(480/2-string.len("L+R : Options")*8/2-10, posY, "L+R : Options", blanc)
	screen:print(480-string.len("O : Precedent")*8-10, posY, "O : Precedent", blanc)
end

function LuaMp3.next(mode)
	if mode == "suivant" then
		if selecteur[1].s < (#fichier + 1) then
			i = selecteur[1].s + 1
			if i < (#fichier + 1) then
				if string.upper(string.sub(fichier[i].name, -3)) == "MP3" then
					selecteur[1].s = selecteur[1].s +1
					Mp3me.stop()
					Mp3me.load(fichier[selecteur[1].s].name)
					Mp3me.play()
				end
			end
		end
	elseif mode == "precedent" then
		if selecteur[1].s < (#fichier + 1) and selecteur[1].s > 2 then
			i = selecteur[1].s - 1
			if i < (#fichier + 1) and i > 2 then
				if string.upper(string.sub(fichier[i].name, -3)) == "MP3" then
					Mp3me.stop()
					selecteur[1].s = selecteur[1].s -1
					Mp3me.load(fichier[selecteur[1].s].name)
					Mp3me.play()
				end
			end
		end
	end
end

function LuaMp3.accent(texte)
	local nomaffiche = string.gsub(texte, "", "e")
	local nomaffiche = string.gsub(nomaffiche, "", "e")
	local nomaffiche = string.gsub(nomaffiche, "", "a")
	local nomaffiche = string.gsub(nomaffiche, "", "c")
	local nomaffiche = string.gsub(nomaffiche, "", "e")
	local nomaffiche = string.gsub(nomaffiche, "", "i")
	local nomaffiche = string.gsub(nomaffiche, "", "E")
	local nomaffiche = string.gsub(nomaffiche, "", "n")
	local nomaffiche = string.gsub(nomaffiche, "", "u")
	
	return nomaffiche
end

function LuaMp3.readTxt(chemin, mode, texte_a_copier)
	local file = io.open(chemin, mode)
	if mode == "r" then
		file:read()
		file:close()
	elseif mode == "w" then
		file:write(texte_a_copier)
		file:close()
	end
end

function LuaMp3.aleatoire()
	local alea = math.random(1+2, #fichier)
	if aleatoire == "true" then
		if Mp3me.gettime() == Mp3me.songTime() then	
			Mp3me.stop()
			Mp3me.load(fichier[alea].name)
			Mp3me.play()
		end
	end
end

function LuaMp3.repetition()
	if repetition == "true" then
		if Mp3me.gettime() == Mp3me.songTime() then
			Mp3me.stop()
			Mp3me.load(fichier[selecteur[1].s].name)
			Mp3me.play()
		end
	elseif repetition == "false" then
		if Mp3me.gettime() == Mp3me.songTime() then
			LuaMp3.next("suivant")
		end
	end
end

function LuaMp3.explo()
	LuaMp3.heure(14, noirI)
	LuaMp3.dir(46)
	LuaMp3.info(259)
	
	screen:blit(454, 2, batterie)
	
	for i = partie, partie + saut - 1 do
		Gu.start3d()
			if string.len(fichier[i].name) >= 60 then
				IntraFont.print(10, y, string.sub(fichier[i].name, 1, 60).."...", 1, noirI, 0)
			elseif string.len(fichier[i].name) <= 60 then
				IntraFont.print(10, y, fichier[i].name, 1, noirI, 0)
			end
		Gu.end3d()

		y = y +48

		if #fichier == i then break end
	end

	y = 90
	
	screen:blit(0, (selecteur[1].s-partie)*47+64, selecteurIMG)
	
	Gu.start3d()
		if string.len(fichier[selecteur[1].s].name) >= 60 then
			IntraFont.print(selecteur[1].posX, (selecteur[1].s-partie)*48+90, fichier[selecteur[1].s].name, 1, blancI, 0)
			selecteur[1].posX = selecteur[1].posX - 1
			if selecteur[1].posX <= 0 - string.len(fichier[selecteur[1].s].name)*7.5 then
				selecteur[1].posX = 10
			end
		elseif string.len(fichier[selecteur[1].s].name) <= 60 then
			IntraFont.print(10, (selecteur[1].s-partie)*48+90, fichier[selecteur[1].s].name, 1, blancI, 0)
		end
	Gu.end3d()

	if pad:up() and not oldpad:up() and lecture ~= true then selecteur[1].s = selecteur[1].s -1 selecteur[1].posX = 10 end
	if pad:down() and not oldpad:down() and lecture ~= true then selecteur[1].s = selecteur[1].s +1 selecteur[1].posX = 10 end

	if selecteur[1].s < 1 then selecteur[1].s = 1 elseif selecteur[1].s > #fichier then selecteur[1].s = #fichier end
	if selecteur[1].s > partie + saut - 1 and partie + saut - 1 ~= #fichier then partie = partie + saut elseif selecteur[1].s < partie then partie = partie - saut 		end
	
	if pad:cross() and not oldpad:cross() and lecture ~= true then
		if fichier[selecteur[1].s].directory == true then
			System.currentDirectory(fichier[selecteur[1].s].name)
			fichier = System.listDirectory()
			table.getn(fichier)
			selecteur[1].s = 1
			partie = 1
		elseif fichier[selecteur[1].s].directory == false and lecture ~= true then
			if string.upper(string.sub(fichier[selecteur[1].s].name, -3)) == "MP3" then
				Mp3me.load(fichier[selecteur[1].s].name)
				Mp3me.play()
				lecture = true
			end
		end
	elseif pad:circle() and not oldpad:circle() and lecture ~= true then
		if System.currentDirectory() ~= "ms0:/" then
			System.currentDirectory("..")
			fichier = System.listDirectory()
			table.getn(fichier)
			selecteur[1].s = 1
		end	
	elseif pad:l() and pad:r() and lecteur ~= true then
		statut = "options"
	elseif pad:hold() and not oldpad:hold() and lecture ~= true then
		local alea = math.random(1+2, #fichier)
		if aleatoire == "true" and string.upper(string.sub(fichier[alea].name, -3)) == "MP3" then
			Mp3me.load(fichier[alea].name)
			Mp3me.play()
			lecture = true
		else
			if System.currentDirectory() == "ms0:/MUSIC" then
				System.message("Lecture aleatoire desactivee, veuillez l'activer pour que l'hombrew choisisse une musique aleatoire", 0)
			end
		end
	end

	if lecture == true then
		screen:clear()
		screen:blit(0, 0, zic)
		
		LuaMp3.aleatoire()
		LuaMp3.repetition()
		
		LuaMp3.heure(14, gris2I)
		LuaMp3.pourcent(480/2-200/2, 83, 200, 4, blanc, bleuC)
		
		screen:blit(480/2-boule:width()/2-97+Mp3me.percent()*2, 79.5, boule)
		
		screen:blit(selecteur[2].posX, 210, selecteurM)
		
		if selecteur[2].s == 1 then selecteur[2].posX = 117 end
		if selecteur[2].s == 2 then selecteur[2].posX = 202 end
		if selecteur[2].s == 3 then selecteur[2].posX = 282 end
		
		screen:blit(480/2-bouton:width()/2, 235, bouton)
		
		if pad:cross() and not oldpad:cross() and lecture ~= false and selecteur[2].s == 1 then
			LuaMp3.next("precedent")
		elseif pad:cross() and not oldpad:cross() and lecture ~= false and selecteur[2].s == 2 then
			Mp3me.pause()
		elseif pad:cross() and not oldpad:cross() and lecture ~= false and selecteur[2].s == 3 then
			LuaMp3.next("suivant")
		end
		
		if Mp3me.artist() == "" or Mp3me.artist() == nil then
			screen:print(480/2-string.len("Inconnu")*8/2, 25, "Inconnu", gris)
		else
			screen:print(480/2-string.len(Mp3me.artist())*8/2, 25, LuaMp3.accent(Mp3me.artist()), gris)
		end
		
		if Mp3me.title() == "" or Mp3me.title() == nil then
			screen:print(480/2-string.len("Inconnu")*8/2, 37, "Inconnu", blanc)
		else
			screen:print(480/2-string.len(Mp3me.title())*8/2, 37, LuaMp3.accent(Mp3me.title()), blanc)
		end
		
		if Mp3me.album() == "" or Mp3me.album() == nil then
			screen:print(480/2-string.len("Inconnu")*8/2, 50, "Inconnu", gris)
		else
			screen:print(480/2-string.len(Mp3me.album())*8/2, 50, LuaMp3.accent(Mp3me.album()), gris)
		end

		if System.currentDirectory() == "ms0:/MUSIC" or System.currentDirectory() == "ms0:/PSP/MUSIC" then
			screen:print(480/2-string.len(selecteur[1].s.." sur "..#fichier)*8/2, 70, selecteur[1].s-2 .." sur "..#fichier-2, blanc)
		end
		
		Gu.start3d()
			IntraFont.print(70, 90, string.sub(Mp3me.gettime(), 4), 1, blancI, 0)
			IntraFont.print(370, 90, string.sub(Mp3me.songTime(), 4), 1, blancI, 0)
		Gu.end3d()
		
		if pad:start() and not oldpad:start() and lecture ~= false then
			lecture = false
			Mp3me.stop()
		elseif pad:right() and not oldpad:right() and lecture ~= false then
			selecteur[2].s = selecteur[2].s +1
		elseif pad:left() and not oldpad:left() and lecture ~= false then
			selecteur[2].s = selecteur[2].s -1
		end
		if selecteur[2].s > 3 then selecteur[2].s = 3 elseif selecteur[2].s < 1 then selecteur[2].s = 1 end
	end
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

while true do
	screen:clear()
	pad = Controls.read()
	
	if statut == "intro" then
		LuaMp3.intro()
	end
	
	if statut == "lecteur" then
		screen:blit(0, 0, fond)
		LuaMp3.explo()
	end
	
	if statut == "options" then
		screen:blit(0, 0, fond)
		
		Gu.start3d()
			IntraFont.print(20, selecteur[3].posY, ">", 1, blancI, noirI2)
			if repetition == "true" then
				IntraFont.print(50, 90, "Lecture rptitif : activ", 1, blancI, noirI2)
			else
				IntraFont.print(50, 90, "Lecture rptitif : dsactiv", 1, blancI, noirI2)
			end
			if aleatoire == "true" then
				IntraFont.print(50, 138, "Lecture alatoire : activ", 1, blancI, noirI2)
			else
				IntraFont.print(50, 138, "Lecture alatoire : dsactiv", 1, blancI, noirI2)
			end
			IntraFont.print(50, 186, "CPU : "..CPU, 1, blancI, noirI2)
			IntraFont.print(50, 234, "Retour", 1, blancI, noirI2)
		Gu.end3d()
		
		if pad:down() and not oldpad:down() and lecture ~= true then selecteur[3].s = selecteur[3].s +1 end
		if pad:up() and not oldpad:up() and lecture ~= true then selecteur[3].s = selecteur[3].s -1 end
		
		if selecteur[3].s > 4 then selecteur[3].s = 4 elseif selecteur[3].s < 1 then selecteur[3].s = 1 end
		
		if selecteur[3].s == 1 then selecteur[3].posY = 90 end
		if selecteur[3].s == 2 then selecteur[3].posY = 138 end
		if selecteur[3].s == 3 then selecteur[3].posY = 186 end
		if selecteur[3].s == 4 then selecteur[3].posY = 234 end
		
		if pad:cross() and not oldpad:cross() and lecture ~= true then
			if selecteur[3].s == 1 then
				if repetition == "true" then
					LuaMp3.readTxt("ms0:/PSP/GAME/LuaMP3/Fichiers/repetition.txt", "w", "false")
					repetition = "false"
				elseif repetition == "false" then
					LuaMp3.readTxt("ms0:/PSP/GAME/LuaMP3/Fichiers/repetition.txt", "w", "true")
					repetition = "true"
				end
			elseif selecteur[3].s == 2 then
				if aleatoire == "true" then
					LuaMp3.readTxt("ms0:/PSP/GAME/LuaMP3/Fichiers/aleatoire.txt", "w", "false")
					aleatoire = "false"
				elseif aleatoire == "false" then
					LuaMp3.readTxt("ms0:/PSP/GAME/LuaMP3/Fichiers/aleatoire.txt", "w", "true")
					aleatoire = "true"
				end
			elseif selecteur[3].s == 3 then
				if CPU == "133" then	
					LuaMp3.readTxt("ms0:/PSP/GAME/LuaMP3/Fichiers/cpu.txt", "w", "266")
					System.setReg()
					CPU = "266"
				elseif CPU == "266" then
					LuaMp3.readTxt("ms0:/PSP/GAME/LuaMP3/Fichiers/cpu.txt", "w", "333")
					System.setHigh()
					CPU = "333"
				elseif CPU == "333" then
					LuaMp3.readTxt("ms0:/PSP/GAME/LuaMP3/Fichiers/cpu.txt", "w", "133")
					System.setLow()
					CPU = "133"
				end
			elseif selecteur[3].s == 4 then
				statut = "lecteur"
			end
		end
	end
	
	screen.flip()
	screen.waitVblankStart()
	oldpad = pad
end